#include "Seznam.h"
Seznam::Seznam()
{
	hlava = new Prvek();
	zarazka = hlava;
}
void Seznam::pridejNaZacatek(T data)
{
	Prvek* novyPrvek = new Prvek();
	novyPrvek->nastavData(data);
	novyPrvek->nastavDalsi(hlava);
	hlava = novyPrvek;
}
void Seznam::pridejNaKonec(T data)
{
	Prvek* novaZarazka = new Prvek();
	zarazka->nastavData(data);
	zarazka->nastavDalsi(novaZarazka);
	zarazka = novaZarazka;
}
bool Seznam::jePrazdny()
{
	return hlava == zarazka;
}
void Seznam::odstranPrvni()
{
	Prvek* prvniPrvek = hlava;
	hlava = prvniPrvek->vratDalsi();
	delete prvniPrvek;
}
void Seznam::odstranPosledni()
{
	Prvek* posledniPrvek = hlava;
	while(posledniPrvek->vratDalsi() != zarazka)
	{
		posledniPrvek = posledniPrvek->vratDalsi();
	}
	delete zarazka;
	zarazka = posledniPrvek;
}
void Seznam::vyprazdni()
{
	while(!jePrazdny())
	{
		odstranPrvni();
	}
}
void Seznam::vypis()
{
	cout << "+----------------------+---------------------+---------------------+" << endl;
	cout << "|        Nazev         |         Cena        |       Mnozstvi      |" << endl;
	cout << "+----------------------+---------------------+---------------------+" << endl;
	Prvek* aktualniPrvek = hlava;
	while(aktualniPrvek != zarazka)
	{
		cout << "| ";
		cout << setw(20) << aktualniPrvek->vratData().nazev << " | ";
		cout << setw(16) << aktualniPrvek->vratData().cena << " Kc | ";
		cout << setw(16) << aktualniPrvek->vratData().mnozstvi << " ks | ";
		cout << endl;
		aktualniPrvek = aktualniPrvek->vratDalsi();
	}
	cout << "+----------------------+---------------------+---------------------+" << endl;
}
bool Seznam::ulozDoSouboru(string nazevSouboru)
{
	ofstream soubor;
	soubor.open(nazevSouboru.data(), ios::out);
	if(!soubor.is_open())
	{
		return false;
	}
	Prvek* aktualniPrvek = hlava;
	while(aktualniPrvek != zarazka)
	{
		soubor << aktualniPrvek->vratData().nazev << ";"
			 << aktualniPrvek->vratData().cena << ";"
			 << aktualniPrvek->vratData().mnozstvi;
		if(aktualniPrvek->vratDalsi() != zarazka)
		{
			soubor << endl;
		}
		aktualniPrvek = aktualniPrvek->vratDalsi();
	}
	soubor.close();
	return true;
}
bool Seznam::nactiZeSouboru(string nazevSouboru)
{
	ifstream soubor;
	soubor.open(nazevSouboru.data(), ios::in);
	if(!soubor.is_open())
	{
		return false;
	}
	while(!soubor.eof())
	{
		Produkt produkt;
		string cenaRetezec, mnozstviRetezec;
		getline(soubor, produkt.nazev, ';');
		getline(soubor, cenaRetezec, ';');
		getline(soubor, mnozstviRetezec, '\n');
		stringstream(cenaRetezec) >> produkt.cena;
		stringstream(mnozstviRetezec) >> produkt.mnozstvi;
		pridejNaKonec(produkt);
	}
	soubor.close();
	return true;
}
int Seznam::sectiMnozstvi()
{
	int mnozstvi = 0;
	Prvek* aktualniPrvek = hlava;
	while(aktualniPrvek != zarazka)
	{
		mnozstvi += aktualniPrvek->vratData().mnozstvi;
		aktualniPrvek = aktualniPrvek->vratDalsi();
	}
	return mnozstvi;
}
Seznam::~Seznam()
{
	vyprazdni();
	delete hlava;
}
