#include <iostream>
#include "Seznam.h"

using namespace std;

const int KONEC = 8;
const string SOUBOR = "produkty.csv";

void vymazObrazovku()
{
	system("cls");
}
void pauza()
{
	system("pause");
}
void vypisMenu()
{
	vymazObrazovku();
	cout << "+---------------------------------+" << endl;
	cout << "|     ###  Obchudecek  ###        |" << endl;
	cout << "+---------------------------------+" << endl;
	cout << "|                                 |" << endl;
	cout << "| 1. Vypis seznam                 |" << endl;
	cout << "| 2. Vypis mnozstvi               |" << endl;
	cout << "| 3. Uloz do souboru              |" << endl;
	cout << "| 4. Nacti ze souboru             |" << endl;
	cout << "| 5. Pridej produkt               |" << endl;
	cout << "| 6. Odstran produkt              |" << endl;
	cout << "| 7. Vyprazdni seznam             |" << endl;
	cout << "| 8. Konec                        |" << endl;
	cout << "|                                 |" << endl;
	cout << "+---------------------------------+" << endl;
}
int nactiCeleCislo()
{
	int cislo;
	cin >> cislo;
	while(!cin.good())
	{
		cin.clear();
		cin.ignore(9999, '\n');
		cout << "Nezadali jste cele cislo!" << endl;
		cout << "Zopakujte svou volbu: ";
		cin >> cislo;
	}
	return cislo;
}
int nactiVolbuMenu()
{
	cout << "Zadejte volbu: ";
	int cislo = nactiCeleCislo();
	while(cislo < 1 || KONEC < cislo)
	{
		cout << "Zadali jste spatnou volbu!" << endl;
		cout << "Zopakujte svou volbu: ";
		cislo = nactiCeleCislo();
	}
	return cislo;
}
void vypisSeznam(Seznam* seznam)
{
	seznam->vypis();
}
void vypisMnozstvi(Seznam* seznam)
{
	int celkoveMnozstvi = seznam->sectiMnozstvi();
	cout << "Celkem je k dispozici " << celkoveMnozstvi << " kolacku" << endl;
}
void ulozDoSouboru(Seznam* seznam)
{
	bool vysledek = seznam->ulozDoSouboru(SOUBOR);
	if(vysledek)
	{
		cout << "Seznam byl uspesne ulozen do souboru!" << endl;
	}
	else
	{
		cout << "Behem ukladani seznamu do souboru nastala chyba!" << endl;
	}
}
void nactiZeSouboru(Seznam* seznam)
{
	bool vysledek = seznam->nactiZeSouboru(SOUBOR);
	if(vysledek)
	{
		cout << "Seznam byl uspesne nacten ze souboru!" << endl;
	}
	else
	{
		cout << "Behem nacitani seznamu ze souboru nastala chyba!" << endl;
	}	
}
void pridejProdukt(Seznam* seznam)
{
	Produkt produkt;
	produkt.nazev = "Kremrole";
	produkt.mnozstvi = 10;
	produkt.cena = 30;
	seznam->pridejNaKonec(produkt);
	cout << "Produkt byl uspesne pridan do seznamu!" << endl;
}
void odstranProdukt(Seznam* seznam)
{
	seznam->odstranPosledni();
	cout << "Produkt byl uspesne odstranen ze seznamu!" << endl;
}
void vyprazdniSeznam(Seznam* seznam)
{
	seznam->vyprazdni();
	cout << "Seznam byl uspesne vymazan!" << endl;
}
void ukonciProgram()
{
	cout << "Na shledanou!" << endl;
}
int main()
{
	Seznam* seznam = new Seznam();
	nactiZeSouboru(seznam);	
	int volba;
	do
	{
		vypisMenu();
		volba = nactiVolbuMenu();
		vymazObrazovku();
		switch(volba)
		{
			case 1: vypisSeznam(seznam); break;
			case 2: vypisMnozstvi(seznam); break;
			case 3: ulozDoSouboru(seznam); break;
			case 4: nactiZeSouboru(seznam); break;
			case 5: pridejProdukt(seznam); break;
			case 6: odstranProdukt(seznam); break;
			case 7: vyprazdniSeznam(seznam); break;
			default: ukonciProgram();
		}
		pauza();
	}
	while(volba != KONEC);
	delete seznam;
	return 0;
}
